#include <aocpp/Startup.hpp>

#include <cstdlib>
#include <iostream>
#include <optional>
#include <memory>
#include <fstream>
#include <utility>

#define DOCTEST_CONFIG_IMPLEMENT
#include <doctest.h>

auto main(int argc, char ** argv) -> int
{
  if (std::getenv("DOCTEST")) {
      return doctest::Context{argc, argv}.run();
  }

  try {
    Main(std::cin, std::cout);
  } catch (std::exception const& e) {
    std::cerr << "Program failed: " << e.what() << std::endl;
    return 1;
  }
}
